'(
Datumskram V0.9 letzte Bearbeitung 01.03.18

fast alles (CC) by-nc-sa Joachim Fossie Br Reiter (bascom@fakedomain.de) 2018

Alles mgliche rund um Kalenderberechnungen.
WICHTIG: Bei allen Routinen ausser dem Schaltjahr sind die Jahresangaben
         zweistellig. Ab Jahr 2000
         Auch wichtig. Benutzt "Config Submode = New" bentigt also
         keine Deklarationen mehr

Schaltjahr
    Gibt zu vierstelligem Jahr zurck ob Schaltjahr oder nicht

Kalenderwoche
    Gibt zu Datum die Kalenderwoche zurck
    Hoffe die Routine klappt immer, Fehler bitte melden

Donnerstag
    Berechnet zu dem Datum (SYSDAY) an welchem Tag in der Woche der Donnerstag ist
    Wird zur Berechnung der Kalenderwoch bentigt

Feiertag
    Prft ob bergegebenen Datum im angegebenen Bundesland ein
    Feiertag ist und gibt Nummer des Feiertages (1-17) zurck

Feiertagsdatum
    Gibt fr Jahr und Nummer des Feiertags das Datum in SYSDAY-Long zurck

Ostertag
    Berechnet den Ostertag, also den Tag des Jahres an dem Ostersonntag ist.
    Wird bentigt zur Feiertagsberechnung
    Ergebnis ist brigens 1-basierend. Also der 1.1. ist Tag 1 und nicht 0

Check_ft_bl
    Prft ob Feiertag (FT) im Bundesland (BL) auch gltig ist. Wird fr
    Feiertagsberechnung bentigt

Feiertagsname
    Gibt zu der Nummer des Feiertages den Namen des Feiertages zurck

Checksommerzeit
    Auf Sommer- bzw. Winterzeit prfen und ggf. das Datum stellen

Monatslaenge (c) j-g-s 2014
    Gibt die Anzahl der Tage im Monat zurck

DiffDate
    Gibt Differenz in Jahren, Monaten, Tagen, Stunden, Minuten und Sekunden zurck
')


' Bitmasken in welchem Bundesland welcher Feiertag noch einer ist
'Seltsamerweise klappt es nicht in Bitschreibweise, deshalb Hex
'                                                 Bundesland  BBBBHHHMNNRSSSST
'                                                             WYEBBHEVIWPLNTHH
Const Nj = &HFFFF                                           'B1111111111111111 Neujahr
Const Hk = &HC004                                           'B1100000000000100 Heilige drei Knige
Const Kf = &HFFFF                                           'B1111111111111111 Karfreitag
Const Os = &HFFFF                                           'B1111111111111111 Ostersonntag
Const Om = &HFFFF                                           'B1111111111111111 Ostermontag
Const Ta = &HFFFF                                           'B1111111111111111 Tag der Arbeit
Const Ch = &HFFFF                                           'B1111111111111111 Christi Himmelfahrt
Const Ps = &HFFFF                                           'B1111111111111111 Pfingstsonntag
Const Pm = &HFFFF                                           'B1111111111111111 Pfingstmontag
Const Fl = &HC270                                           'B1100001001110000 Fronleichnam
Const Mh = &H8010                                           'B1000000000010000 Maria Himmelfahrt
Const Te = &HFFFF                                           'B1111111111111111 Tag der deutschen Einheit
Const Rf = &H110D                                           'B0001000100001101 Reformationstag
Const Ah = &HC007                                           'B1100000001110000 Allerheiligen
Const Bt = &H0008                                           'B0000000000001000 Buss- und Bettag
Const W1 = &HFFFF                                           'B1111111111111111 1.Weihnachtsfeiertag
Const W2 = &HFFFF                                           'B1111111111111111 2.Weihnachtsfeiertag

' Bundeslnder Konstanten fr Feiertagsroutine
Const Bw = 15                                               ' BW = Baden-Wrtemberg
Const By = 14                                               ' BY = Bayern
Const Be = 13                                               ' BE = Berlin
Const Bb = 12                                               ' BB = Brandenburg
Const Hb = 11                                               ' HB = Bremen
Const Hh = 10                                               ' HH = Hamburg
Const He = 9                                                ' HE = Hessen
Const Mv = 8                                                ' MV = Mecklenburg Vorpommern
Const Ni = 7                                                ' NI = Niedersachsen
Const Nw = 6                                                ' NW = Nordrhein-Westfalen
Const Rp = 5                                                ' RP = Rheinland-Pfalz
Const Sl = 4                                                ' SL = Saarland
Const Sn = 3                                                ' SN = Sachsen
Const St = 2                                                ' ST = Sachsen-Anhalt
Const Sh = 1                                                ' SH = Schleswig-Holstein
Const Th = 0                                                ' TH = Thringen



'#########################################################################
'# Auf Schaltjahr prfen
'# Gibt 0 = kein Schaltjahr oder 1 = Schaltjahr zurck
'#########################################################################
Function Schaltjahr(jahr As Word) As Byte
    Local Temp As Word
    Local Ergo As Byte

    Ergo = 0
    Temp = Jahr Mod 4
    If Temp = 0 Then
        Temp = Jahr Mod 100
        If Temp <> 0 Then
            Ergo = 1
        Else
            Temp = Jahr Mod 400
            If Temp = 0 Then Ergo = 1
        End If
    End If
    Schaltjahr = Ergo
End Function



'#########################################################################
'# Gibt zu Datum Kalenderwoche zurck
'# Gespickt bei http://www.salesianer.de/util/kalwoch.html
'# und auf BASCOM angepasst
'#########################################################################
Function Kalenderwoche(tag As Byte , Monat As Byte , Jahr As Byte) As Byte

    Local D_day As Byte
    Local D_month As Byte
    Local D_year As Byte


    Local D_temp As Word
    Local D1 As Word
    Local D2 As Word

    D_day = Tag
    D_month = Monat
    D_year = Jahr
    D_temp = Sysday(d_day)
    D1 = Donnerstag(d_temp)                                 ' Ausrechnen wann Donnerstag in der Woche ist

    D_day = Date(d1)                                        ' dann ermitteln wann 1.KW ist
    D_day = 4                                               ' kann ggf. im Vorjahr liegen (53KW)
    D_month = 1
    D_temp = Sysday(d_day)
    D2 = Donnerstag(d_temp)

    D_temp = D1 - D2                                        ' Differenz zwischen den zwei Daten
    D_temp = D_temp / 7                                     ' Und durch Wochen teilen
    Incr D_temp                                             ' und eins dabei

    Kalenderwoche = D_temp                                  ' Und schon ist es da
End Function


'#########################################################################
'# Gehrt zur Kalenderwochenberechnung
'# Berechnet zu dem Datum an welchem Tag in der Woche der Donnerstag ist
'#########################################################################
Function Donnerstag(dosysday As Word) As Word

    Local Temp As Word

    Temp = Dayofweek(dosysday)                              ' Was fr ein Tag war es (0=Mo, 6=So)
    Temp = 3 - Temp                                         ' Donnerstag ermitteln
    Donnerstag = Dosysday + Temp                            ' und neues Datum zurckgeben

End Function



'#########################################################################
'# Prft ob an bergegebenen Datum ein Feiertag ist
'# Rckgabewert 0 = kein Feiertag, 1-17 je nach Feiertag
'#########################################################################
Function Feiertag(tag As Byte , Monat As Byte , Jahr As Byte , Byval Bundesland As Byte) As Byte
    Local Ft_day As Byte
    Local Ft_month As Byte
    Local Ft_year As Byte
    Local Ft_temp As Word

    Local Temp As Word
    Local Count As Byte

    Ft_day = Tag
    Ft_month = Monat
    Ft_year = Jahr
    Ft_temp = Sysday(ft_day)

    '###### Jahrestag mit Feiertagsliste vergleichen
    For Count = 1 To 17
        ' Wenn Feiertag und auch im Bundeslang einer, dann raus
        If Ft_temp = Feiertagsdatum(jahr , Count) Then
            ' und auch im Bundeslang einer, dann raus
            If Check_ft_bl(count , Bundesland) = 1 Then Exit For
            ' wenn nicht im Bundesland, dann trotzdem raus, ohne Ergebnis
            Count = 0
            Exit For
        End If
    Next Count

    If Count = 18 Then Count = 0                            ' Nix gefunden, dann war es das
    Feiertag = Count                                        ' Ergebnis zurckgeben
End Function



'#########################################################################
'# Gibt fr Jahr und Nummer des Feiertags das Datum in SYSDAY-Long zurck
'#########################################################################
Function Feiertagsdatum(jahr As Byte , Ft As Byte) As Word

    Local Ft_day As Byte
    Local Ft_month As Byte
    Local Ft_year As Byte

    Local Ot As Byte
    Local Sj As Byte

    Local Ergo As Word
    Local Temp As Word
    Local Wday As Byte

    Ot = Ostertag(jahr)                                     ' schonmal den Ostertag berechnen
    Ergo = Jahr + 2000                                      ' und mal sehen obs ein Schaltjahr  ist
    Sj = Schaltjahr(ergo)

    Ft_day = 1                                              ' wann ist der 1.1. des Jahres
    Ft_month = 1                                            ' (Neujahr)
    Ft_year = Jahr
    Ergo = Sysday(ft_day) - 1

    Select Case Ft                                          ' und los gehts mit dem Ausrechnen
    Case 1                                                  ' Neujahr
        Temp = 1
    Case 2                                                  ' Hl. 3 Knige
        Temp = 6
    Case 3                                                  ' Karfreitag
        Temp = Ot - 2
    Case 4                                                  ' Ostersonntag
        Temp = Ot
    Case 5                                                  ' Ostermontag
        Temp = Ot + 1
    Case 6                                                  ' Tag der Arbeit
        Temp = 121 + Sj
    Case 7                                                  ' Christi Himmelfahrt
        Temp = Ot + 39
    Case 8                                                  ' Pfingstsonntag
        Temp = Ot + 49
    Case 9                                                  ' Pfingstmontag
        Temp = Ot + 50
    Case 10                                                 ' Fronleichnam
        Temp = Ot + 60
    Case 11                                                 ' Maria Himmelfahrt
        Temp = 227 + Sj
    Case 12                                                 ' Tag der deutschen Einheit
        Temp = 276 + Sj
    Case 13                                                 ' Reformationstag
        Temp = 304 + Sj
    Case 14                                                 ' Allerheiligen
        Temp = 305 + Sj
    Case 15                                                 ' Buss- und Bettag
        Ft_day = 24
        Ft_month = 12
        Ft_year = Jahr
        Temp = Sysday(ft_day)
        Wday = Dayofweek(temp) + 1
        Wday = Wday Mod 7
        Temp = 358 + Sj
        Temp = Temp - Wday                                  ' 4.Advent (So)
        Temp = Temp - 32                                    ' 32 Tage vor 4.Advent (Mi)
    Case 16                                                 ' 1.Weihnachtstag
        Temp = 359 + Sj
    Case 17                                                 ' 2.Weihnachtstag
        Temp = 360 + Sj
    End Select

    Ergo = Ergo + Temp
    Feiertagsdatum = Ergo                                   ' Ergebnis bergeben

End Function



'#########################################################################
'# Berechnet den Ostertag, also Ostersonntag
'# Gibt zu zweistelligem Jahr den Tag des Jahres zurck an dem Ostern ist
'#########################################################################
Function Ostertag(jahr As Byte) As Byte

    Local Temp_jahr As Word
    Local D As Integer , E As Integer , M As Integer , T As Integer
    Local Count As Byte , Ot As Byte

    ' ###### Ostertag berechnen
    Temp_jahr = Jahr + 2000
    Ot = Schaltjahr(temp_jahr)
    D = Temp_jahr Mod 19
    D = D * 19
    D = D + 24
    D = D Mod 30
    E = Temp_jahr Mod 4
    Shift E , Left                                          '   Alt  E = E * 2
    T = Temp_jahr Mod 7
    Shift T , Left , 2                                      '   Alt  T = T * 4
    E = E + T
    T = D * 6
    T = T + 5
    E = E + T
    E = E Mod 7
    M = 2
    Ot = Ot + 59
    T = 22 + E
    T = T + D
    If T > 31 Then
        T = T - 31
        M = 3
        Ot = Ot + 31
    End If

    If M = 3 Then
        Temp_jahr = Temp_jahr Mod 19
        If T = 26 Then T = 19
        If T = 25 And D = 28 And Temp_jahr >= 11 Then T = 18
    End If

    Ostertag = Ot + T

End Function



'#########################################################################
'# Prft ob Feiertag (FT) im Bundesland (BL) auch gltig ist
'# Gibt 0 = kein Feiertag oder 1 = ist in BL Feiertag zurck
'#########################################################################
Function Check_ft_bl(ft As Byte , Bl As Byte) As Byte
    Local Temp As Word

    Select Case Ft
    Case 1
       Temp = Nj
    Case 2
       Temp = Hk
    Case 3
       Temp = Kf
    Case 4
       Temp = Os
    Case 5
       Temp = Om
    Case 6
       Temp = Ta
    Case 7
       Temp = Ch
    Case 8
       Temp = Ps
    Case 9
       Temp = Pm
    Case 10
       Temp = Fl
    Case 11
       Temp = Mh
    Case 12
       Temp = Te
    Case 13
       Temp = Rf
    Case 14
       Temp = Ah
    Case 15
       Temp = Bt
    Case 16
       Temp = W1
    Case 17
       Temp = W2
    End Select

    If Temp.bl = 1 Then Temp = 1 Else Temp = 0
    Check_ft_bl = Temp
End Function




'#########################################################################
'# Gibt zu der Nummer des Feiertages den Namen des Feiertages zurck
'#########################################################################
Function Feiertagsname(ft_nr As Byte) As String * 25

    Local Tempstring As String * 25

    Tempstring = ""
    Select Case Ft_nr
    Case 1
        Tempstring = "Neujahr"
    Case 2
        Tempstring = "Heilige Drei Knige"
    Case 3
        Tempstring = "Karfreitag"
    Case 4
        Tempstring = "Ostersonntag"
    Case 5
        Tempstring = "Ostermontag"
    Case 6
        Tempstring = "Tag der Arbeit"
    Case 7
        Tempstring = "Christi Himmelfahrt"
    Case 8
        Tempstring = "Pfingstsonntag"
    Case 9
        Tempstring = "Pfingstmontag"
    Case 10
        Tempstring = "Fronleichnam"
    Case 11
        Tempstring = "Maria Himmelfahrt"
    Case 12
        Tempstring = "Tag der Deutschen Einheit"
    Case 13
        Tempstring = "Reformationstag"
    Case 14
        Tempstring = "Allerheiligen"
    Case 15
        Tempstring = "Buss- und Bettag"
    Case 16
        Tempstring = "1.Weihnachtsfeiertag"
    Case 17
        Tempstring = "2.Weihnachtsfeiertag"
    End Select
    Feiertagsname = Tempstring
End Function



'#########################################################################
'# Auf Sommer- bzw. Winterzeit prfen und ggf. das Datum stellen
'# Check_dat= Datum und Uhrzeit zum Prfen in Syssec. Wird ggf um 3600 Sekunden
'#            erhht oder erniedrigt
'# Workflag = 0 nur checken und Status anpassen,
'#          = 1 Checken, Status anpassen und Uhr stellen
'#
'# Status   = 1 Sommerzeit
'#          = 0 Winterzeit
'#########################################################################
Sub Checksommerzeit(check_dat As Long , Byval Workflag As Byte , Status As Byte)

    Local D_sec As Byte
    Local D_min As Byte
    Local D_hour As Byte
    Local D_day As Byte
    Local D_month As Byte
    Local D_year As Byte
    Local Dayofdate As Byte                                 ' Tag zu Datum
    Local Sz_flag As Byte

    Sz_flag = 0                                             ' Erst mal Winterzeit annehmen
    D_day = Date(check_dat)                                 ' Syssec zerlegen weil Jahr gebraucht wird

    D_sec = 0                                               ' Was fr ein Tag ist
    D_min = 0
    D_hour = 2
    D_day = 1                                               ' der 1.4. des Jahres
    D_month = 4

    Dayofdate = Dayofweek(d_day)                            ' 0 = Montag bis 6 = Sonntag
    D_day = 31 - Dayofdate                                  ' Letzten Sonntag ermitteln
    D_month = 3                                             ' im Mrz = Start Sommerzeit

    ' wenn Datum grsser ist, also Sommerzeit, checken auf Ende
    If Check_dat >= Syssec(d_sec) Then
        D_hour = 3                                          ' letzten Sonntag im Oktober
        D_day = 1
        D_month = 11
        Dayofdate = Dayofweek(d_day)                        '0 = Montag bis 6 = Sonntag
        D_day = 31 - Dayofdate                              ' Letzten Sonntag ermitteln
        D_month = 10                                        ' im Oktober
        If Check_dat < Syssec(d_sec) Then Sz_flag = 1       ' Ist immer noch in der Sommerzeit
    End If

    If Sz_flag = 0 Then                                     ' Keine Sommerzeit
        If Status = 1 Then
            Status = 0
            If Workflag = 1 Then Check_dat = Check_dat - 3600
        End If
    Else                                                    ' Doch Sommerzeit
        If Status = 0 Then
            Status = 1
            If Workflag = 1 Then Check_dat = Check_dat + 3600
        End If
    End If

End Sub


'#########################################################################
'# Monatslaenge(Monat,Jahr) = 28,29,30,31 Tage  (c) j-g-s 2014
'# Gibt die Anzahl der Tage im Monat zurck
'#########################################################################
Function Monatslaenge(byval Monat As Byte , Byval Jahr As Word ) As Byte
    Local Temp As Byte

    If Monat = 2 Then                                       '  Sonderbehandlung fr Februar
        Temp = Schaltjahr(jahr)                             ' ist es ein Schaltjahr?
        Temp = 28 + Temp
    Else
        Temp = Monat > 7                                    ' ab August (8 Monat) verschiebt es sich um 1
        Temp = Monat + Temp                                 ' zu den Monaten addieren  | 1 2 3 4 5 6 7 9 10 11 12 13
        Temp = Temp And 1                                   ' prfen ob ungerade Zahl  | 1 0 1 0 1 0 1 1 0  1  0  1
        Temp = 30 + Temp                                    ' ergibt 30 oder 31 Tage
    End If                                                  ' ganz einfach
    Monatslaenge = Temp
End Function


'#########################################################################
'# DIFFDATE berechnet die Differenz zwischen zwei Daten
'# Als Ergebnis gib es ein Array mit der Differenz in
'# Jahren, Monaten, Tagen, Stunden, Minuten und Sekunden zurueck
'# Hin Start- und Enddatum im Long-SysSec-Format
'# Zurck Array mit Differenz
'# 1 = Jahr, 2 = Monat, 3 = Tag, 4 = Stunde, 5 = Minute, 6 = Sekunde
'#########################################################################
Sub Diffdate(byval From_date As Long , Byval To_date As Long , Byref Ergo_array() As Byte) As Byte
    local fsec As Byte , fmin As Byte , fhour As Byte
    local fday As Byte , fmonth As Byte , fyear As Byte
    local tsec As Byte , tmin As Byte , thour As Byte
    local tday As Byte , tmonth As Byte , tyear As Byte

    Local Temp_string As String * 16 , Temp1_string As String * 2 , Temp_byte As Byte

    ' Zerlege From_date in einzelne Felder
    fsec = Time(from_date)
    fday = date(from_date)
    tsec = Time(to_date)
    tday = date(to_date)

    If fsec > Tsec Then                                 ' Wenn From_Sekunden grsser als to_Sekunden,
        Tsec = Tsec + 60                                  ' dann eine Minute dazu addieren
        Incr fmin                                        ' und die bei nchster Berechnung auch addieren
    End If
    Ergo_array(6) = Tsec - Fsec                         ' ermittele Differenz

    If Fmin > Tmin Then                                 ' Dito wie Sekunden
        Tmin = Tmin + 60
        Incr Fhour
    End If
    Ergo_array(5) = Tmin - Fmin

    If Fhour > Thour Then                                 ' Dito wie Sekunden nur mit 24 Stunden
        Thour = Thour + 24
        Incr Fday
    End If
    Ergo_array(4) = Thour - Fhour

    If Fday > Tday Then                                 ' Dito wie Sekunden
        Temp_byte = Tmonth - 1                               ' nur dass Anzahl der Tage
        Temp_byte = Monatslaenge(temp_byte , Tyear)         ' des To_Vormonat genommen wird
        Tday = Tday + Temp_byte
        Incr Fmonth
    End If
    Ergo_array(3) = Tday - Fday

    If Fmonth > Tmonth Then                                 ' Dito wie Sekunden nur mit 12 Monaten
        Tmonth = Tmonth + 12
        Incr Fyear
    End If
    Ergo_array(2) = Tmonth - Fmonth

    If Fyear > Tyear Then                                 ' Dito wie Sekunden wird aber nicht benutzt
        Tyear = Tyear + 1
    End If
    Ergo_array(1) = Tyear - Fyear

End Sub
