'#########################################################################
'### Routinen fr KBR-Display
'#########################################################################

'###### Konstanten

Const Saa1_adr = &H74
Const Saa2_adr = &H72
Const Saa3_adr = &H70
Const Dlr_data_adr = &H40
Const Dlr_status_adr = &H42
'Const Button_adr = &H4E
Const Button_adr = &H4F
Const Led_adr = &H46

Dim Saa_data As Byte
Saa_multi Alias Saa_data.0                                  ' b1 Multiplex On/off
Saa_1_3 Alias Saa_data.1                                    ' b1 Digit 1 + 3 on
Saa_2_4 Alias Saa_data.2                                    ' b2 Digit 2 + 4 on
Saa_test Alias Saa_data.3                                   ' b3 Segment-Test off
Saa_3ma Alias Saa_data.4                                    ' b4 3mA Segment Output
Saa_6ma Alias Saa_data.5                                    ' b5 6mA Segment Output
Saa_12ma Alias Saa_data.6                                   ' b6 12mA Segment Output


Dim Dlr_status As Byte
Dlr_a0 Alias Dlr_status.0
Dlr_a1 Alias Dlr_status.1
Dlr_wr Alias Dlr_status.2
Dlr_clr Alias Dlr_status.3
Dlr_blank Alias Dlr_status.4

Dim Led_status As Byte
Led_0 Alias Led_status.0
Led_1 Alias Led_status.1
Led_2 Alias Led_status.2
Led_3 Alias Led_status.3
Led_4 Alias Led_status.4
Led_5 Alias Led_status.5
Led_6 Alias Led_status.6
Led_7 Alias Led_status.7
Led_8 Alias Dlr_status.5
Led_9 Alias Dlr_status.6
Led_10 Alias Dlr_status.7

Dim Disp_text As String * 30
Dim Disp_text_array(32) As Byte At Disp_text Overlay        ' Und in Bytes
Dim Disp_start As Byte

'#########################################################################
'###### SUBs
'#########################################################################


'#########################################################################
'### Initialisieren der Anzeige
'#########################################################################
Sub Kbr_init

    Led_status = &B11111111                                 ' Alle Leds AUS
    Set Led_8
    Set Led_9
    Set Led_10
    Call Led_write
    Call Dlr_init
    Call Saa_init
End Sub



Sub Led_write()

'    ' Leds 8-10
'    I2cstart                                                ' start condition
'    I2cwbyte Dlr_status_adr                                 ' slave address
'    I2cwbyte Dlr_status                                     ' Display Register 1
'    I2cstop

    'Leds 0-7
    I2cstart                                                ' start condition
    I2cwbyte Led_adr                                        ' slave address
    I2cwbyte Led_status
    I2cstop

End Sub




Sub Dlr_init

    Reset Dlr_a0
    Reset Dlr_a1
    Reset Dlr_wr
    Reset Dlr_clr
    Set Dlr_blank

    I2cstart                                                ' start condition
    I2cwbyte Dlr_status_adr                                 ' slave address
    I2cwbyte Dlr_status                                     ' Write Config
    Waitms 2
    Reset Dlr_a0
    Reset Dlr_a1
    Set Dlr_wr
    Set Dlr_clr
'    Set Dlr_blank
    I2cwbyte Dlr_status                                     ' Write Config
    I2cstop

End Sub


Sub Dlr_write(byval Text As String * 4)
    Local Z As String * 1

    Local Temp As Byte , Count As Byte

    Dlr_status = Dlr_status And &B11111100                  ' Mask A0 und A1
    For Count = 4 To 1 Step -1
        Z = Mid(text , Count , 1)
        Temp = Asc(z)
        I2cstart
        I2cwbyte Dlr_data_adr                               ' Daten
        I2cwbyte Temp                                       ' an Port ausgeben
        I2cstop

        Temp = 4 - Count
        Dlr_status = Dlr_status And &B11111100
        Dlr_status = Dlr_status + Temp
        I2cstart
        I2cwbyte Dlr_status_adr
        Reset Dlr_wr
        I2cwbyte Dlr_status
        Set Dlr_wr
        I2cwbyte Dlr_status
        I2cstop
    Next Count

End Sub





Sub Saa_init
    Set Saa_multi                                           ' b1 Multiplex On
    Set Saa_1_3                                             ' b1 Digit 1 + 3 on
    Set Saa_2_4                                             ' b2 Digit 2 + 4 on
    Reset Saa_test                                          ' b3 Segment-Test off
    Set Saa_3ma                                             ' b4 3mA Segment Output
    Set Saa_6ma                                             ' b5 6mA Segment Output
'    If Full_segment = 1 Then
'        Reset Saa_12ma                                      ' b6 12mA Segment Output
'    Else
        Set Saa_12ma                                        ' b6 12mA Segment Output
'    End If

    I2cstart                                                ' start condition
    I2cwbyte Saa1_adr                                       ' slave address
    I2cwbyte 0                                              ' Select Control Register
    I2cwbyte Saa_data                                       ' Write Config
    I2cwbyte 0                                              ' no Display
    I2cwbyte 0
    I2cwbyte 0
    I2cwbyte 0
    I2cstop

    I2cstart                                                ' start condition
    I2cwbyte Saa2_adr                                       ' slave address
    I2cwbyte 0                                              ' Control Register
    I2cwbyte Saa_data
    I2cwbyte 0                                              ' no Display
    I2cwbyte 0
    I2cwbyte 0
    I2cwbyte 0
    I2cstop

    I2cstart                                                ' start condition
    I2cwbyte Saa3_adr                                       ' slave address
    I2cwbyte 0                                              ' Control Register
    I2cwbyte Saa_data
    I2cwbyte 0                                              ' no Display
    I2cwbyte 0
    I2cwbyte 0
    I2cwbyte 0
    I2cstop
End Sub


Sub Saa_write(byval S_adr As Byte , Byval Text As String)
    Local Temp As Byte , Font_data As Byte                  '  , Temp As Byte At Temp1 Overlay
    Local Count As Byte , Z As String * 1

    I2cstart                                                ' start condition
    I2cwbyte S_adr                                          ' slave address
    I2cwbyte 1                                              ' Display Register 1
    Text = "    " + Text
    Text = Right(text , 4)
    For Count = 1 To 4
        Z = Mid(text , Count , 1)
        If Z <> " " Then
            Temp = Asc(z)
            If Temp > 128 Then
                Temp = Temp - 176
                Font_data = Lookup(temp , Saa_font)
                Font_data = Font_data + 128                 'DP dabei
            Else
                Temp = Val(z)
                Font_data = Lookup(temp , Saa_font)
            End If
        Else
            Font_data = 0
        End If
        I2cwbyte Font_data
    Next Count
    I2cstop

End Sub


'#########################################################################
'### Scrolle mit neuem Text durch
'#########################################################################
Sub Scroll_text()
    Local Count As Byte , Temp As Byte , Outtext As String * 4

    Outtext = Mid(disp_text , Disp_start , 4)
    Call Dlr_write(outtext)
    Incr Disp_start

    Temp = Len(disp_text) - 4
    If Disp_start > Temp Then Disp_start = 1
End Sub



'#########################################################################
'### Formatiert Zahl in String mit SLen Zeichen und Nullgefllt
'#########################################################################
Function Formatstr(byval Wert As Long , Byval Slen As Byte , Byval Zero As Byte) As String
    Local Tempstring As String * 30

    Tempstring = Space(slen) + Str(wert)

    Tempstring = Right(tempstring , Slen)
    If Zero = 1 Then
        Replacechars Tempstring , " " , "0"
    End If
    Formatstr = Tempstring
End Function


'#########################################################################
'# DiffDays berechnet die Differenz zwischen zwei Daten in Tagen, Stunden,
'# Minuten und Sekunden
'# Als Ergebnis gib es ein Array mit der Differenz
'# Hin Start- und Enddatum im Long-SysSec-Format
'# Zurck Array mit Differenz
'#########################################################################
Sub Diffday(byval From_date As Long , Byval To_date As Long , Byref Ergo_array() As Word) As Byte
    Local Diff As Long , Long_temp As Long

    Diff = To_date - From_date                              ' Diiferenz berechnen

    Long_temp = Diff / 86400                                ' Tage berechnen
    Ergo_array(1) = Long_temp                               ' Tage berechnen
    Diff = Diff Mod 86400                                   ' Der Rest

    Long_temp = Diff / 3600
    Ergo_array(2) = Long_temp                               ' Stunden berechnen
    Diff = Diff Mod 3600                                    ' Der Rest

    Ergo_array(3) = Diff / 60                               ' Minuten berechnen
    Diff = Diff Mod 60                                      ' Der Rest

    Ergo_array(4) = Diff                                    ' Sekunden
End Sub