 '-----------------------------------------------------------------------------------------
'name                     : Turner Resttime
'copyright                : (c) 2019 Joachim Fossie Br Reiter
'-----------------------------------------------------------------------------------------

$version 0 , 0 , 32
$regfile = "m328pdef.dat"
$hwstack = 128                                              ' default use 32
$swstack = 128                                              ' default use 10
$framesize = 128
$crystal = 16000000
$baud = 9600
Baud = 9600

Config Submode = New

$lib "i2c_twi.lbx"
$include "TurnerTime1.INC"
$include "Datumskram.INC"

Config Portb = Input                                        ' Port Als Eingang
Portb = &HFF                                                ' und Pull Ups ein
Full_segment Alias Pinb.0
Default_date Alias Pinb.1

'#########################################################################
'###### Konstanten

Const Ds3231_adr_w = &HD0                                   '208 Schreibaddresse des Ds3231
Const Ds3231_adr_r = &HD1                                   '209 Leseadresse des DS3231
'Const Ds1307_adr_w = &HD0                                   '208 Schreibaddresse des Ds3231
'Const Ds1307_adr_r = &HD1                                   '209 Leseadresse des DS3231
Config Clock = User                                         ' Interne Time/Date Routinen fr Bascom konfigurieren
Config Date = Dmy , Separator = .                           ' ANSI-Format


'#########################################################################
'###### DIMs der Variablen
' Zhler fr Blinker
' BIT 0 =    125 ms
' BIT 1 =    250 ms
' BIT 2 =    500 ms
' BIT 3 =  1.000 ms
' BIT 4 =  2.000 ms
' BIT 5 =  4.000 ms
' BIT 6 =  8.000 ms
' BIT 7 = 16.000 ms
Dim Blinktakt As Byte
Bl_sek Alias Blinktakt.3
Bl_hsek Alias Blinktakt.2
Dim Blt As Byte

Dim Temp As Byte
Dim Tempstring As String * 30
Dim Tempstring_data(32) As Byte At Tempstring Overlay

Dim Rec_string As String * 30
Dim Rec_data(32) As Byte At Rec_string Overlay
Dim Rec_count As Byte
Dim Rec_char As Byte

Dim Date_str As String * 8
Dim Time_str As String * 8
Dim E_sec As Byte , E_min As Byte At E_sec + 1 , E_hour As Byte At E_min + 1
Dim E_day As Byte At E_hour + 1 , E_month As Byte At E_day + 1 , E_year As Byte At E_month + 1
Dim Yeartemp As Integer

Dim Akt_time As Long
Dim End_time As Long
Dim Old_time As Long
Dim Diff_time As Long
Dim Temp_time As Long

Dim D_diff(6) As Integer

Dim Waittime As Byte

Dim Buttonstate As Byte
Dim Buttonstate_old As Byte
Scroll_key Alias 0
Volume_key Alias 1
Menu_key Alias 2
Enter_key Alias 3
Prev_key Alias 4
Next_key Alias 5
Dim Taste As Byte

Dim _wday As Byte                                           ' Wochentag

Dim E_status As Eram Byte At &H01
Dim E_end_time As Eram Long At &H02

Dim T_status As Eram Byte At &H06
Dim E_text As Eram String * 20 At &H10

Dim Modus As Byte                                           ' Welcher Modus ist ausgewhlt
Dim Modus_next As Byte                                      ' wer soll als nchster
Dim Status As Byte
Scroll_lock Alias Status.0
Waitflag Alias Status.1
Keypress Alias Status.2
Readtime Alias Status.3
Keyboardread Alias Status.4

Dim Editfeld As Byte
Editfeld = 1

Dim Edf As Byte                                             ' Hilfsvariable fr Editfeld
Dim Editdata(3) As Byte
Dim Olddata As Word                                         ' Alter Wert
Dim Etyp As Byte                                            ' Welcher Datentyp zum Editieren
Dim Tsaa_adr As Byte

'########################################################################
'###### INIT
'########################################################################
' I2C-Config
Config Scl = Portc.5                                        'I2C SCL
Config Sda = Portc.4                                        'I2C SDA

Config Twi = 100000                                         'BUS-Takt,
I2cinit

' Timer alle 125ms
Config Timer1 = Timer , Prescale = 1024 , Compare_a = Disconnect , Clear_timer = 1
Compare1a = 1960 ' Old 1953 fr 125ms, neu etwas langsamer fr Zeiteinlesung
On Compare1a Timerint_isr
Enable Compare1a

Config Portd.2 = Input
Set Pind.2
Config Int0 = Falling
On Int0 Readbutton_isr
Enable Int0

Config Serialin = Buffered , Size = 20                      ' Buffered Input for all Uarts
Open "Com1:" For Binary As #1                               ' Open Uarts for In/Out

' Interrupts freigeben
Enable Interrupts

If Default_date = 0 Then T_status = 74

If E_status <> 74 Then                                      ' Keine Daten vorhanden
    Time_str = "14:45:00"                                   ' dann fixe Daten
    Date_str = "10.07.22"
    End_time = Syssec(time_str , Date_str)
    E_end_time = End_time
    E_status = 74                                           ' und merken
End If

End_time = E_end_time

Call Kbr_init

Gosub Readbutton_isr
Buttonstate_old = Buttonstate

Gosub Getdatetime                                           ' Zeit aktualisieren
I2cstart                                                    ' Generate start code
I2cwbyte Ds3231_adr_w                                       ' send address
I2cwbyte 0                                                  ' starting address in 1307
I2cwbyte _sec
I2cstop

Waittime = 255


Gosub Getdatetime
Call Dlr_write( "JR22")
Wait 3
Akt_time = Syssec()                                         ' Und Sekunden holen
Print "Restanzeige V0.5 (C)JR2022"
Print "Aktuelles Datum: " ; Date(akt_time) ; "  " ; Time(akt_time)
Print "Enddatum       : " ; Date(end_time) ; "  " ; Time(end_time)
Print
Disp_text = E_text
Print "Text: " ; Disp_text
Print : Print "H<CR> fr Hilfe"


'#########################################################################
'###### MAIN
Do
  If Blt.1 <> Blinktakt.1 Then
    If Disp_text <> "" Then Scroll_text
    Blt.1 = Blinktakt.1
  End If

  If Readtime = 1 Then
    Gosub Getdatetime
    Akt_time = Syssec()                                     ' Und Sekunden holen
    Reset Readtime
  End If

  Select Case Modus                                         ' Wo sind wir?
  Case Is < 100                                             ' Im Normalbetrieb
    Gosub Normalbetrieb

  Case Is < 200                                             ' Editierbetrieb
    Gosub Editierbetrieb

  End Select


        '### Handle Serielle
    If Ischarwaiting(#1) = 1 Then
        Rec_char = Inkey(#1)
        If Rec_char = 13 Then
            Gosub Parse_Serial
        Elseif Rec_char = 10 Then
            ' Ignorieren
        Else
            if len(rec_string)<30 Then Rec_string = Rec_string + Chr(rec_char)
        End If
    End If


  If Keyboardread = 1 Then
    Disable Interrupts
    I2cstart
    I2cwbyte Button_adr
    I2crbyte Buttonstate , Nack
    I2cstop
    Enable Interrupts
    Reset Keyboardread

    '#######################################################################
    ' Tastaturabfrage
    If Buttonstate_old <> Buttonstate Then
      Buttonstate_old = Buttonstate_old Xor Buttonstate
      If Buttonstate.scroll_key = 0 And Buttonstate_old.scroll_key = 1 Then Set Taste.scroll_key
      If Buttonstate.menu_key = 0 And Buttonstate_old.menu_key = 1 Then Set Taste.menu_key
      If Buttonstate.enter_key = 0 And Buttonstate_old.enter_key = 1 Then Set Taste.enter_key
      If Buttonstate.prev_key = 0 And Buttonstate_old.prev_key = 1 Then Set Taste.prev_key
      If Buttonstate.next_key = 0 And Buttonstate_old.next_key = 1 Then Set Taste.next_key
      If Buttonstate.volume_key = 0 And Buttonstate_old.volume_key = 1 Then Set Taste.volume_key
      Buttonstate_old = Buttonstate
      Keypress = 1
    End If

  End If
Loop

End                                                         ' Programmende



'#########################################################################
'###### Unterprogramme frs Bearbeiten der Daten
'#########################################################################

Normalbetrieb:
  If Modus = 0 Then                                         ' Init Modus
    Set Waitflag
    Disp_text = E_text
    Disp_text = "    " + Disp_text + "    "
    Dlr_status = Dlr_status Or &B11100000
    Led_status = &HFF
    Modus = 10
  End If

  Diff_time = End_time - Akt_time

  If Akt_time <> Old_time Then
    Toggle Led_0                                            ' Sekundenblinker
    Call Led_write()                                        ' und ausgeben

    Select Case Modus                                       ' Welcher Modus ist gewhlt
    Case 10
      Waittime = 20
      Modus_next = 20
      Set Led_3
      Reset Led_7
      Incr Modus

    Case 11                                                 ' Anzeige Restzeit
      Call Diffday(akt_time , End_time , D_diff(1))
      Tempstring = Formatstr(d_diff(1) , 4 , 0)
      Call Saa_write(saa1_adr , Tempstring)
      Tempstring = Formatstr(d_diff(2) , 2 , 0)
      Call Saa_write(saa2_adr , Tempstring)
      Tempstring = Formatstr(d_diff(3) , 2 , 1)
      Tempstring = Tempstring + Formatstr(d_diff(4) , 2 , 1)
      Tempstring_data(2) = Tempstring_data(2) + 128
      Call Saa_write(saa3_adr , Tempstring)

    Case 20
      Waittime = 5
      Modus_next = 25
      Set Led_7
      Reset Led_6
      Incr Modus

    Case 21                                                 ' Anzeige Datum Heute
      E_day = Date(akt_time)
      Tempstring = Formatstr(e_day , 2 , 1)
      Call Saa_write(saa1_adr , Tempstring)
      Tempstring = Formatstr(e_month , 2 , 1)
      Call Saa_write(saa2_adr , Tempstring)
      Yeartemp = E_year + 2000
      Tempstring = Formatstr(yeartemp , 4 , 0)
      Call Saa_write(saa3_adr , Tempstring)

    Case 25
      Waittime = 5
      Modus_next = 30
      Set Led_6
      Reset Led_5
      Incr Modus

    Case 26                                                 ' Anzeige Uhrzeit Heute
      Set Led_6
      Reset Led_5
      E_sec = Time(akt_time)
      Tempstring = Formatstr(e_hour , 2 , 1)
      Call Saa_write(saa1_adr , Tempstring)
      Tempstring = Formatstr(e_min , 2 , 1)
      Call Saa_write(saa2_adr , Tempstring)
      Tempstring = Formatstr(e_sec , 2 , 1)
      Call Saa_write(saa3_adr , Tempstring)

    Case 30
      Waittime = 5
      Modus_next = 35
      Set Led_5
      Reset Led_4
      Incr Modus

    Case 31                                                 ' Anzeige Datum Ende
      E_day = Date(end_time)
      Tempstring = Formatstr(e_day , 2 , 0)
      Call Saa_write(saa1_adr , Tempstring)
      Tempstring = Formatstr(e_month , 2 , 0)
      Call Saa_write(saa2_adr , Tempstring)
      Yeartemp = E_year + 2000
      Tempstring = Formatstr(yeartemp , 4 , 0)
      Call Saa_write(saa3_adr , Tempstring)

    Case 35
      Waittime = 5
      Modus_next = 10
      Set Led_4
      Reset Led_3
      Incr Modus

    Case 36                                                 ' Anzeige Uhrzeit Ende
      E_sec = Time(end_time)
      Tempstring = Formatstr(e_hour , 2 , 0)
      Call Saa_write(saa1_adr , Tempstring)
      Tempstring = Formatstr(e_min , 2 , 0)
      Call Saa_write(saa2_adr , Tempstring)
      Tempstring = Formatstr(e_sec , 2 , 1)
      Call Saa_write(saa3_adr , Tempstring)

    End Select
    Old_time = Akt_time
  End If

  If Taste.scroll_key = 1 Then Toggle Scroll_lock
  If Taste.menu_key = 1 And Modus > 20 Then
    Modus_next = Modus
    Modus = 100
  End If
  If Taste.next_key = 1 Then Modus = Modus_next

  Taste = 0

Return



'#########################################################################
'### Editierbetrieb
'#########################################################################
Editierbetrieb:

  If Modus = 100 Then                                       ' Init Editiermodus
    Reset Waitflag
    Disp_text = "    Edit Daten    "
    Editfeld = 2
    Edf = 8
    Modus = 110
    Olddata = &HFFFF
  End If

  Select Case Modus
  Case 110
    Select Case Modus_next                                  ' Was wird editiert
    Case 21                                                 ' Datum Heute
      E_day = Date(akt_time)
      Editdata(3) = E_day
      Editdata(2) = E_month
      Editdata(1) = E_year
      Etyp = 0                                              '0 = Datum

    Case 26                                                 ' Uhrzeit Heute
      E_sec = Time(akt_time)
      Editdata(3) = E_hour
      Editdata(2) = E_min
      Editdata(1) = E_sec
      Etyp = 1                                              '16-31 = Zeit

    Case 31                                                 ' Datum Ende
      E_day = Date(end_time)
      Editdata(3) = E_day
      Editdata(2) = E_month
      Editdata(1) = E_year
      Etyp = 0                                              '0-15 = Datum

    Case 36                                                 ' Uhrzeit Ende
      E_sec = Time(end_time)
      Editdata(3) = E_hour
      Editdata(2) = E_min
      Editdata(1) = E_sec
      Etyp = 1                                              '16-31 = Zeit
    End Select
    Modus = 120

  Case 120
    If Editfeld = 255 Then                                  ' Ende des Edit, underrun
      Select Case Modus_next                                ' Was wird gespeichert
      Case 21                                               ' Datum Heute
        _day = Editdata(3)
        _month = Editdata(2) Month
        _year = Editdata(1)
        Gosub Setdate

      Case 26                                               ' Uhrzeit Heute
        _hour = Editdata(3)
        _min = Editdata(2)
        _sec = Editdata(1)
        Gosub Settime

      Case 31                                               ' Datum Ende
        E_sec = Time(end_time)
        E_day = Editdata(3)
        E_month = Editdata(2)
        E_year = Editdata(1)
        End_time = Syssec(e_sec)
        E_end_time = End_time

      Case 36                                               ' Uhrzeit Ende
        E_sec = Time(end_time)
        E_hour = Editdata(3)
        E_min = Editdata(2)
        E_sec = Editdata(1)
        End_time = Syssec(e_sec)
        E_end_time = End_time
      End Select

      'Daten speichern
      Modus = 150
    Else
      If Editfeld <> Edf Then
        Dlr_status = Dlr_status Or &B11100000               ' Passende LED EIN
        Edf = Editfeld + 5
        Reset Dlr_status.edf
        Edf = Editfeld
      End If

      If Etyp = 0 Then                                      ' Datum checken
        Select Case Editfeld
        Case 2                                              ' Tag
          If Editdata(editfeld + 1) > 31 Then Editdata(editfeld + 1) = 1
          If Editdata(editfeld + 1) = 0 Then Editdata(editfeld + 1) = 31
        Case 1                                              ' Monat
          If Editdata(editfeld + 1) > 12 Then Editdata(editfeld + 1) = 1
          If Editdata(editfeld + 1) = 0 Then Editdata(editfeld + 1) = 12
        Case 0                                              ' Jahr
          If Editdata(editfeld + 1) > 50 Then Editdata(editfeld + 1) = 50
          If Editdata(editfeld + 1) < 19 Then Editdata(editfeld + 1) = 19
        End Select
      Else                                                  ' Uhrzeit checken
        Select Case Editfeld
        Case 2                                              ' Stunde
          If Editdata(editfeld + 1) = &HFF Then Editdata(editfeld + 1) = 23
          If Editdata(editfeld + 1) > 23 Then Editdata(editfeld + 1) = 0
        Case 1                                              ' Minute
          If Editdata(editfeld + 1) = &HFF Then Editdata(editfeld + 1) = 59
          If Editdata(editfeld + 1) > 59 Then Editdata(editfeld + 1) = 0
        Case 0                                              ' Sekunde
          If Editdata(editfeld + 1) = &HFF Then Editdata(editfeld + 1) = 59
          If Editdata(editfeld + 1) > 59 Then Editdata(editfeld + 1) = 0
        End Select

      End If

      If Keypress = 1 Then
        Tsaa_adr = Editfeld * 2
        Tsaa_adr = Tsaa_adr + Saa3_adr
        If Etyp = 0 And Editfeld = 0 Then Temp = 4 Else Temp = 2
        Tempstring = Formatstr(editdata(editfeld + 1) , Temp , 0)
        Call Saa_write(tsaa_adr , Tempstring)
        Olddata = Editdata(editfeld + 1)
        Reset Keypress
      End If
    End If

  Case 150                                                  ' Ende Edit, Normalanzeige
    Waittime = &HFF
    Modus = 0

  End Select

  If Taste.menu_key = 1 Then Modus = 150                    ' Men, dann Raus, das wars
  If Taste.enter_key = 1 Then Decr Editfeld                 ' Nchstes Feld

  If Taste.prev_key = 1 Then Decr Editdata(editfeld + 1)
  If Taste.next_key = 1 Then Incr Editdata(editfeld + 1)

  Taste = 0
Return


'#########################################################################
'# Datum und Uhrzeit aus RTC auslesen
Parse_Serial:

    Rec_count = Len(rec_string)
    Select Case Rec_data(1)
    '#################################################################
    '# (D) Aktuelles Datum und Uhrzeit
    Case 68
        Tempstring = Mid(rec_string , 2 , 2)
        _day = Val(tempstring)
        Tempstring = Mid(rec_string , 4 , 2)
        _month = Val(tempstring)
        Tempstring = Mid(rec_string , 6 , 2)
        _year = Val(tempstring)
        Tempstring = Mid(rec_string , 8 , 2)
        _hour = Val(tempstring)
        Tempstring = Mid(rec_string , 10 , 2)
        _min = Val(tempstring)
        Tempstring = Mid(rec_string , 12 , 2)
        _sec = Val(tempstring)
        Gosub Setdatetime
        Print #1, "Datum: " ; Date$ ; "  Uhrzeit: " ; Time$


    '# (E) Enddatum und Uhrzeit
    Case 69
        Tempstring = Mid(rec_string , 2 , 2)
        E_day = Val(tempstring)
        Tempstring = Mid(rec_string , 4 , 2)
        E_month = Val(tempstring)
        Tempstring = Mid(rec_string , 6 , 2)
        E_year = Val(tempstring)
        Tempstring = Mid(rec_string , 8 , 2)
        E_hour = Val(tempstring)
        Tempstring = Mid(rec_string , 10 , 2)
        E_min = Val(tempstring)
        Tempstring = Mid(rec_string , 12 , 2)
        E_sec = Val(tempstring)
        Temp_time = Syssec(e_sec)
        Time_str = Time(temp_time) : Date_str = Date(temp_time)
        Print #1 , "Datum: " ; Date_str ; "  Uhrzeit: " ; Time_str
        End_time = Temp_time
        E_end_time = End_time
        E_status = 74                                       ' und merken


    '# (T) Text
    Case 84
      If Rec_count < 22 Then
        Tempstring = Mid(rec_string , 2)
        E_text = Tempstring
        Print #1 , "Displaytext: " ; Tempstring
      Else
        Print #1 , "Error Text"
      End If



    '#################################################################
    '# (N) Neustart
    Case 78
        If Mid(rec_string , 2 , 8) = "RRRRRRRR" Then
            Print #1, "RESET"
            Goto _reset
        End If


    '#################################################################
    '# (H) Hilfe
    Case 72
        Print #1 , "Restzeitanzeige V0.5 (C)JR20222"
        Print #1 , "Terminalfunktionen"
        Print #1 , ""
        Print #1 , "Aktuelles Datum und Zeit setzen   Dddmmyyhhmmss"
        Print #1 , "Enddatum und Zeit setzen          Eddmmyyhhmmss"
        Print #1 , "                                  dd = Tag, mm =Monat,yy =Jahr"
        Print #1 , "                                  hh = Stunde, mm = Minute, ss =Sekunde"
        Print #1 , "Displaytext (20 Zeichen)          Tabcdefghijklmnopqrst"
        Print #1 , "Neustart                          NRRRRRRRR"
        Print #1 , "Diese Hilfe                       H"
        Print #1 , "Alle Eingaben mit Enter abschliessen"
                Case Else
        Print #1 , "Fehler! H<CR> = Hilfe"

    End Select

    Rec_string = ""

Return


'#########################################################################
'# Datum und Uhrzeit aus RTC auslesen
Getdatetime:
    I2cstart                                                ' Generate start code
    I2cwbyte Ds3231_adr_w                                   ' send address
    I2cwbyte 0                                              ' start address in 1307

    I2cstart                                                ' Generate start code
    I2cwbyte Ds3231_adr_r                                   ' lese ein
    I2crbyte Temp , Ack
    _sec = Makedec(temp)

    I2crbyte Temp , Ack                                     ' MINUTES
    _min = Makedec(temp)

    I2crbyte Temp , Ack                                     ' Hours
    _hour = Makedec(temp)

    I2crbyte Temp , Ack                                     ' Day of Week
    _wday = Makedec(temp)

    I2crbyte Temp , Ack                                     ' Day of Month
    _day = Makedec(temp)

    I2crbyte Temp , Ack                                     ' Month of Year
    _month = Makedec(temp)

    I2crbyte Temp , Nack                                    ' Year
    _year = Makedec(temp)

    I2cstop

Return



'#########################################################################
'# Datum und Uhrzeit in RTC schreiben
Setdatetime:
    Gosub Setdate
    Gosub Settime
Return



'#########################################################################
'# Uhrzeit in RTC schreiben
Settime:
    I2cstart                                                ' Generate start code
    I2cwbyte Ds3231_adr_w                                   ' send address
    I2cwbyte 0                                              ' starting address

    Temp = Makebcd(_sec)
    I2cwbyte Temp

    Temp = Makebcd(_min)
    I2cwbyte Temp

    Temp = Makebcd(_hour)
    I2cwbyte Temp

    I2cstop
Return


'#########################################################################
'# Datum in RTC schreiben
Setdate:
        I2cstart                                            ' Generate start code
        I2cwbyte Ds3231_adr_w                               ' send address
        I2cwbyte 3                                          ' starting address

        Temp = Makebcd(_wday)
        I2cwbyte Temp

        Temp = Makebcd(_day)
        I2cwbyte Temp

        Temp = Makebcd(_month)
        I2cwbyte Temp

        Temp = Makebcd(_year)
        I2cwbyte Temp

        I2cstop
Return


Timerint_isr:
  ' bit 0 =   125ms
  ' bit 1 =   250ms
  ' bit 2 =   500ms
  ' bit 3 = 1.000ms
  ' bit 4 = 2.000ms
  ' bit 5 = 4.000ms
  ' bit 6 = 8.000ms
  ' bit 7 = 16.000ms
  Incr Blinktakt

  If Blt.3 <> Blinktakt.3 Then                            ' Sekunden takt
    If Waitflag = 1 Then
      If Waittime > 0 Then
        Decr Waittime
      Else
        If Scroll_lock = 0 Then Modus = Modus_next
      End If
    End If
    Blt.3 = Blinktakt.3
    Led_1 = Not Scroll_lock
    Set ReadTime
  End If
Return


'######
Readbutton_isr:
  Set Keyboardread
Return


Saa_font:
Data &B00111111                                             '0
Data &B00000110                                             '1
Data &B01011011                                             '2
Data &B01001111                                             '3
Data &B01100110                                             '4
Data &B01101101                                             '5
Data &B01111100                                             '6
Data &B00000111                                             '7
Data &B01111111                                             '8
Data &B01100111                                             '9
Data &B10000000                                             'DP


$eeprom
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Data "RESTZEIT V0.4 (C)22" , 0